<?php
/*

 * Extra Safety Check While Registering For MyBB 1.2.9
 * By: LeX-
 * Website: http://www.thingiej.be
 * Version: 1.0

*/
$plugins->add_hook('member_register_start', 'wnr_register');

$plugins->add_hook('datahandler_user_validate', 'wnr_do_register');

function wnr_info()
{
	return array(
		'name'			=> 'Dodatkowe pytanie antyspamowe podczas rejestracji',
		'description'	=> 'Podczas rejestracji użytkownicy muszą odpowiedzieź na dodatkowe pytanie antyspamowe.',
		'website'		=> 'http://www.thingiej.be/',
		'author'		=> 'LeX- (poprawki dla MyBBoard.pl, Łukasz "LukasAMD" Tkacz)',
		'authorsite'	=> 'http://www.thingiej.be/',
		'version'		=> '1.0',
	);
}

function wnr_activate()
{
	global $db, $mybb;

	$wnr_template = array(
		"tid"		=> NULL,
		"title"		=> 'member_register_wnr',
		"template"	=> $db->escape_string('<br />
<fieldset class="trow2">
<legend><strong>Pytanie antyspamowe</strong></legend>
<table cellspacing="0" cellpadding="{$theme[\'tablespace\']}">
<tr>
<td><span class="smalltext">Podaj poprawną odpowiedź na pytanie aby udowodnić, że nie jesteś botem.</span></td>
<td rowspan="2" align="center"><strong>{$wnr_question}</td>
</tr>
<tr>
<td><input type="text" class="textbox" name="wnr_answer" value="" /><input type="hidden" name="wnr_hidden" value="{$wnr_hidden}" /></td>
</tr>
</table>
</fieldset>'),
		"sid"		=> "-1",
		"version"	=> "1.0",
		"dateline"	=> "1148741714",
	);

	$db->insert_query("templates", $wnr_template);

	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	// MEMBERPROFILE
	find_replace_templatesets("member_register", '#{\$regimage}#', "{\$regimage}{\$wnr}");


	$wnr_group = array(
		"name"			=> "wnr_group",
		"title"			=> "Rejestracja - Pytanie antyspamowe.",
		"description"	=> "Podczas rejestracji użytkownicy muszą odpowiedzieź na dodatkowe pytanie antyspamowe.",
		"disporder"		=> "25",
		"isdefault"		=> "no",
	);

	$db->insert_query("settinggroups", $wnr_group);
	$gid = $db->insert_id();

	$new_setting = array(
		'name'			=> 'wnr_status',
		'title'			=> 'Status modyfikacji',
		'description'	=> 'Określa, czy dodatkowe pytanie antyspamowe ma być zadawane.',
		'optionscode'	=> 'yesno',
		'value'			=> 'yes',
		'disporder'		=> '1',
		'gid'			=> intval($gid)
	);

	$db->insert_query('settings', $new_setting);

	$new_setting2 = array(
		'name'			=> 'wnr_question',
		'title'			=> 'Pytania',
		'description'	=> 'Lista pytań oraz poprawnych odpowiedzi możliwych do wylosowania.<br /> Schemat: <strong>pytanie|odpowiedź</strong>',
		'optionscode'	=> 'textarea',
		'value'			=> 'Czy lew jest kotem?|tak
Czy jesteś botem?|nie
Jakiego koloru jest banan?|żółty
Ile daje nam dwa plus dwa?|cztery
Jakiego koloru jest truskawka?|czerwona
Czy jesteś człowiekiem?|tak
Jakiego koloru jest mleko?|białe
Jakiego koloru jest niebo?|niebieskie
Dwa razy trzy daje nam?|sześć
Jak nazywa się stolica Polski?|Warszawa',
		'disporder'		=> '2',
		'gid'			=> intval($gid)
	);

	$db->insert_query('settings', $new_setting2);

	$new_setting3 = array(
		'name'			=> 'wnr_error',
		'title'			=> 'Powiadomienie o błędzie',
		'description'	=> 'Informacja wyświetlana użytkownikowi gdy niepoprawnie odpowie na pytanie.',
		'optionscode'	=> 'text',
		'value'			=> 'Odpowiedź na pytanie antyspamowe jest niepoprawna. Spróbuj ponownie.',
		'disporder'		=> '3',
		'gid'			=> intval($gid)
	);

	$db->insert_query('settings', $new_setting3);

	rebuildsettings();
}

function wnr_deactivate()
{
	global $mybb, $db;
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'member_register_wnr'");

	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='wnr_status'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='wnr_question'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='wnr_error'");
	$db->delete_query("settinggroups", "name='wnr_group'");

	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	//REMOVING MEMBERPROFILE
	find_replace_templatesets("member_register", '#'.preg_quote('{$wnr}').'#', '',0);

	rebuildsettings();
}
function wnr_template()
{
	global $mybb, $db;

	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	$query = $db->simple_select(TABLE_PREFIX.'templates', 'template', "title='member_register' AND sid!='-2'");
	while($template = $db->fetch_array($query))
	{
		if(strpos($template['template'], 'wnr') === false)
		{
			find_replace_templatesets("member_register", '#{\$regimage}#', "{\$regimage}{\$wnr}");
		}
	}
}
function wnr_template_info()
{
	global $db;

	// CHANGES
	// TEMPLATE|FIND|HOW|CHANGE
	$change = array('template' => 'member_register', 'find' => '{$regimage}', 'how' => 'After', 'change' => '{$wnr}' );

	return array(
		'name'			=> 'Dodatkowe pytanie antyspamowe podczas rejestracji',
		'changes'  		=> $change,
		'version'		=> '1.0',
	);
}

function wnr_register()
{
	global $db, $mybb, $templates, $wnr, $theme;

	if($mybb->settings['wnr_status'] != "no")
	{
		// GET A QUESTION
		$question = explode("\n", stripslashes($mybb->settings['wnr_question']));
		srand((double)microtime()*1000000);
		$numb = (rand(1, sizeof($question)) - 1);
		$answerex = explode("|", $question[$numb]);
		$wnr_question = $answerex[0];
		$wnr_hidden = $numb;
		eval("\$wnr = \"".$templates->get("member_register_wnr")."\";");
	}
}
function wnr_do_register($reg)
{
	global $db, $mybb, $templates, $wnr, $theme;

	if($mybb->settings['wnr_status'] != "no" && strpos($_SERVER['REQUEST_URI'], 'member.php'))
	{
		// ANSWER
		$wnr_answer = trim($db->escape_string($mybb->input['wnr_answer']));
		// HIDDEN VAR
		$wnr_hidden = intval($mybb->input['wnr_hidden']);
		// GET CORRECT ANSWER FROM QUESTION
		$question = explode("\n", stripslashes($mybb->settings['wnr_question']));
		$answer = explode("|", $question[$wnr_hidden]);
		$correct_answer = trim($answer[1]);
		if($wnr_answer != $correct_answer || $wnr_answer == "")
		{
			$reg->set_error($db->escape_string($mybb->settings['wnr_error']));
			return $reg;
		}
	}
}
?>